<?php


namespace app\cbcrm\controller\manage;

use app\cbcrm\controller\BaseUser;
use app\cbcrm\model\admin\AuthMenuModel;
use app\cbcrm\model\manage\RoleModel;
use think\App;
use think\Request;

class Role extends BaseUser
{
    protected $model = null;

    public function __construct(Request $request)
    {
        parent::__construct($request);

        $this->model = new RoleModel();
    }

    public function index()
    {
        $list = $this->model->getList($this->wid);

        $departmentData = getTreeData($list,0);

        return success('返回成功',$departmentData);
    }

    public function getMenuList()
    {
        $role_id = \request()->get('role_id',0,'intval');

        $authMenuModel = app()->make(AuthMenuModel::class);

        $menuList = $authMenuModel->getRoleMenu($role_id);

        return success('返回成功',$menuList);
    }

    public function add()
    {
        $params = \request()->post('form');
        $params['roles'] = implode(',',$params['menus']);
        $params['wid'] = $this->wid;
        $result = $this->model->saveData($params);
        if ($result) {
            return success('添加成功');
        }else{
            return error('添加失败');
        }
    }

    public function edit()
    {
        $id = \request()->post('id',0,'intval');
        $params = \request()->post('form');
        $params['roles'] = implode(',',$params['menus']);
        $params['wid'] = $this->wid;
        $row = $this->model->where('id',$id)->find();
        if (!$row) {
            return error('内容未找到');
        }
        $result = $row->save($params);
        if ($result) {
            return success('编辑成功');
        }else{
            return error('编辑失败');
        }
    }

    public function del()
    {
        $id = \request()->delete('id',0,'intval');
        $row = $this->model->where('id',$id)->where('wid',$this->wid)->find();
        if (!$row) {
            return error('未找到该内容');
        }
        $row->delete();
        return success('删除成功');
    }
}
